variables:
  GIT_STRATEGY: none
  WORKSPACES_REPO: "git@js-er-code.jsc.nasa.gov:tf/tf_workspaces.git"
  WORKSPACES_PATH: "tf_workspaces"
  WORKSPACE_FILE: "full_internal_ssh.yaml"
  WORK_AREA: "package_work_area"
  PACKAGE_NAME: "taskforce_common_library"
  TEST_EXTRAS: ""
  DEB_COMP: "main"
  DEB_ARCH: "amd64"

stages:
  - build
  - package
  - deploy

before_script:
  - apt-get update -qqy
  - rosdep update

build_xenial:
  stage: build
  image: js-er-code.jsc.nasa.gov:5005/tf/tf_image_xenial_kinetic_fast_build:latest
  variables:
    DEB_REPO: "ubuntu-xenial"
    ROS_DISTRO: "kinetic"
    DEB_PREFIX_REL: "opt/nasa/kinetic"
    DEB_PREFIX_ABS: /$DEB_PREFIX_REL
  script:
    - git clone $WORKSPACES_REPO $WORKSPACES_PATH
    - pushd $WORKSPACES_PATH
    - vcs custom --args checkout `gitflow_base_branch -b $CI_COMMIT_REF_NAME` || true
    - vcs custom --args checkout $CI_COMMIT_REF_NAME || true
    - popd
    - catkin_build_package --work-area $CI_PROJECT_DIR/$WORK_AREA --catkin-package-name $PACKAGE_NAME --repository $CI_REPOSITORY_URL --branch $CI_COMMIT_REF_NAME --catkin-workspace $CI_PROJECT_DIR/$WORKSPACES_PATH/$WORKSPACE_FILE --ros-distro $ROS_DISTRO --prefix $DEB_PREFIX_ABS
    - mkdir -p $CI_PROJECT_DIR/$DEB_PREFIX_REL
    - cp -a $DEB_PREFIX_ABS/* $CI_PROJECT_DIR/$DEB_PREFIX_REL
  artifacts:
    paths:
      - $WORK_AREA
      - $DEB_PREFIX_REL
    expire_in: 4 hours
  tags:
    - syslog

package_xenial:
  stage: package
  image: js-er-code.jsc.nasa.gov:5005/tf/tf_image_xenial_kinetic_fast_build:latest
  variables:
    DEB_REPO: "ubuntu-xenial"
    ROS_DISTRO: "kinetic"
    DEB_PREFIX_REL: "opt/nasa/kinetic"
    DEB_PREFIX_ABS: /$DEB_PREFIX_REL
  dependencies:
    - build_xenial
  script:
    - mkdir -p $DEB_PREFIX_ABS
    - cp -a $DEB_PREFIX_REL/* $DEB_PREFIX_ABS
    - catkin_generate_debian --work-area $CI_PROJECT_DIR/$WORK_AREA  --catkin-package-name $PACKAGE_NAME --ros-distro $ROS_DISTRO --prefix $DEB_PREFIX_ABS --from-prefix
    - cp $WORK_AREA/debian_ws/*.deb $CI_PROJECT_DIR
  artifacts:
    paths:
      - ./*.deb

deploy_xenial:
  stage: deploy
  image: js-er-code.jsc.nasa.gov:5005/tf/tf_image_xenial_kinetic_fast_build:latest
  variables:
    DEB_REPO: "ubuntu-xenial"
    ROS_DISTRO: "kinetic"
    DEB_PREFIX_REL: "opt/nasa/kinetic"
    DEB_PREFIX_ABS: /$DEB_PREFIX_REL
  dependencies:
    - package_xenial
  script:
    - artifactory_upload debian --package ./ --repository $DEB_REPO --component $DEB_COMP --architecture $DEB_ARCH --branch $CI_COMMIT_REF_NAME
